#!/bin/bash
#######################################################################
#    Modelio launcher
#
# Parameters available
#  -nl en/fr              : define the user interface language
#  -clean                 : Clean the cached data.
#  -workspace dir_path    : Open th modelio session which using the
#                           "dir_path" directory as workspace data. 
#  -project  proj_name    : Open directly the project_name with modelio 
#  -script script_name.py : Execute a Jython script
#
#######################################################################

####
# if there are graphic bugs, uncomment the following line
#export GDK_NATIVE_WINDOWS=1

####
# Find the Modelio install real path and add it in the PATH system
if [ -L "$0" ] ; then
	SLNK=$(\ls -l "$0"| sed -e "s|.* -> ||")
	if [ "${SLNK:0:1}" != "/" ] ; then
		FILE_PATH=$(dirname $0)/$SLNK
	else
		FILE_PATH=$SLNK
	fi
else
	FILE_PATH=$0
fi
export FULL_PATH=$(cd -P -- "$(dirname -- "$FILE_PATH")" && printf '%s\n' "$(pwd -P)/${FILE_PATH##*/}") 
export MODELIO_PATH=$(dirname "$FULL_PATH")
export PATH=${PATH}:${MODELIO_PATH}
export LD_LIBRARY_PATH="${MODELIO_PATH}/lib":$LD_LIBRARY_PATH
unset MOZILLA_FIVE_HOME
unset GRE_HOME

####
# creation of configuration directory
if [ -n "${HOME}" ] ; then
	export CONFIG_DIR="${HOME}/.modelio/2.2"
	[ -f "${CONFIG_DIR}" ] && rm -f "${CONFIG_DIR}"
	[ ! -d "${CONFIG_DIR}" ] && mkdir -p "${CONFIG_DIR}"
else
	export CONFIG_DIR=""
fi

####
# Config
if [ -n "${CONFIG_DIR}" ] ; then
	cd "${CONFIG_DIR}"
else
	cd
fi

####
# Run
"${MODELIO_PATH}/modelio" $*
